OGRE: Ogre::ShadowRenderable Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::ShadowRenderable Class Reference
Core » Scene

Class which represents the renderable aspects of a set of shadow volume faces. More...

`#include <OgreShadowCaster.h>`

Inheritance diagram for Ogre::ShadowRenderable:
[legend]

## Public Member Functions
| ShadowRenderable ()
| ShadowRenderable (MovableObject *parent, const HardwareIndexBufferSharedPtr &indexBuffer, const VertexData *vertexData, bool createSeparateLightCap, bool isLightCap=false)
virtual | ~ShadowRenderable ()
ShadowRenderable * | getLightCapRenderable (void)
| Get the light cap version of this renderable.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
const HardwareVertexBufferSharedPtr & | getPositionBuffer (void) const
void | getRenderOperation (RenderOperation &op) override
| Gets the render operation required to send this object to the frame buffer.
RenderOperation * | getRenderOperationForUpdate (void)
| Get the internal render operation for set up.
Real | getSquaredViewDepth (const Camera *) const override
| Returns the squared distance between the camera and this renderable.
void | getWorldTransforms (Matrix4 *xform) const override
| Gets the world transform matrix / matrices for this renderable object.
bool | isLightCapSeparate (void) const
| Does this renderable require a separate light cap?
virtual bool | isVisible (void) const
| Should this ShadowRenderable be treated as visible?
void | rebindIndexBuffer (const HardwareIndexBufferSharedPtr &indexBuffer)
| This function informs the shadow renderable that the global index buffer from the SceneManager has been updated.
void | setMaterial (const MaterialPtr &mat)
| Set the material to be used by the shadow, should be set by the caller before adding to a render queue.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Detailed Description

Class which represents the renderable aspects of a set of shadow volume faces.

Note that for casters comprised of more than one set of vertex buffers (e.g. SubMeshes each using their own geometry), it will take more than one ShadowRenderable to render the shadow volume. Therefore for shadow caster geometry, it is best to stick to one set of vertex buffers (not necessarily one buffer, but the positions for the entire geometry should come from one buffer if possible)

## Constructor & Destructor Documentation

## ◆ ShadowRenderable() [1/2]

Ogre::ShadowRenderable::ShadowRenderable | ( |  | ) |
| inline

Referenced by getLightCapRenderable().

## ◆ ShadowRenderable() [2/2]

Ogre::ShadowRenderable::ShadowRenderable | ( | MovableObject * | parent,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const VertexData * | vertexData,
|  | bool | createSeparateLightCap,
|  | bool | isLightCap = false )

## ◆ ~ShadowRenderable()

virtual Ogre::ShadowRenderable::~ShadowRenderable | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ setMaterial()

void Ogre::ShadowRenderable::setMaterial | ( | const MaterialPtr & | mat | ) |
| inline

Set the material to be used by the shadow, should be set by the caller before adding to a render queue.

## ◆ getMaterial()

const MaterialPtr & Ogre::ShadowRenderable::getMaterial | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## ◆ getRenderOperation()

void Ogre::ShadowRenderable::getRenderOperation | ( | RenderOperation & | op | ) |
| inlineoverridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getRenderOperationForUpdate()

RenderOperation * Ogre::ShadowRenderable::getRenderOperationForUpdate | ( | void |  | ) |
| inline

Get the internal render operation for set up.

## ◆ getWorldTransforms()

void Ogre::ShadowRenderable::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## ◆ getSquaredViewDepth()

Real Ogre::ShadowRenderable::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| inlineoverridevirtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## ◆ getLights()

const LightList & Ogre::ShadowRenderable::getLights | ( | void |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ isLightCapSeparate()

bool Ogre::ShadowRenderable::isLightCapSeparate | ( | void |  | ) | const
| inline

Does this renderable require a separate light cap?

If possible, the light cap (when required) should be contained in the usual geometry of the shadow renderable. However, if for some reason the normal depth function (less than) could cause artefacts, then a separate light cap with a depth function of 'always fail' can be used instead. The primary example of this is when there are floating point inaccuracies caused by calculating the shadow geometry separately from the real geometry.

## ◆ getLightCapRenderable()

ShadowRenderable * Ogre::ShadowRenderable::getLightCapRenderable | ( | void |  | ) |
| inline

Get the light cap version of this renderable.

References ShadowRenderable().

## ◆ isVisible()

virtual bool Ogre::ShadowRenderable::isVisible | ( | void |  | ) | const
| inlinevirtual

Should this ShadowRenderable be treated as visible?

## ◆ rebindIndexBuffer()

void Ogre::ShadowRenderable::rebindIndexBuffer | ( | const HardwareIndexBufferSharedPtr & | indexBuffer | ) |

This function informs the shadow renderable that the global index buffer from the SceneManager has been updated.

As all shadow use this buffer their pointer must be updated as well.

Parameters

  indexBuffer | Pointer to the new index buffer.

## ◆ getPositionBuffer()

const HardwareVertexBufferSharedPtr & Ogre::ShadowRenderable::getPositionBuffer | ( | void |  | ) | const
| inline

The documentation for this class was generated from the following file:

- OgreShadowCaster.h